'Church attendance record
'by Charles Dietz 08-26-2004
'email: chasdietz@earthlink.net
'website: http://home.earthlink.net/~chasdietz
'-------------------------------------------------------------------------------------------------------------

#COMPILE EXE
#DIM ALL
#INCLUDE "WIN32API.INC"
#INCLUDE "Attendance.inc"
'#INCLUDE "debug.inc"
#RESOURCE "attendance.pbr"

$ver = "1.30"

FUNCTION PBMAIN
   LOCAL hSysMenu AS DWORD
   DIALOG NEW 0, "Attendance Record", , , 220, 110, %WS_SYSMENU TO hDlg
   CONTROL ADD LABEL, hDlg, -1, "Year:", 10, 20, 40, 12
   CONTROL ADD TEXTBOX, hDlg, %IDC_Year, "", 30, 20, 40, 12
   CONTROL ADD BUTTON, hDlg, %IDC_Holidays, "&Holidays", 60, 50, 45, 25
   CONTROL ADD BUTTON, hDlg, %IDC_View, "&View", 110, 50, 45, 25
   CONTROL ADD BUTTON, hDlg, %IDC_Print, "&Print", 160, 50, 45, 25
   hSysMenu = GetSystemMenu(hDlg, 0)
   InsertMenu hSysMenu, 2, %MF_BYPOSITION OR %MF_STRING, %ID_SysMenu + 1, "About "
   RemoveMenu hSysMenu, 0, %MF_BYPOSITION
   DIALOG SHOW MODAL hDlg, CALL mainDlgProc
END FUNCTION

CALLBACK FUNCTION mainDlgProc()
   LOCAL i, n, fileNum AS LONG
   LOCAL s, fn AS STRING
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         DIM moName(12), dayName(7)
         moName(1) = "January": moName(2) = "February": moName(3) = "March"
         moName(4) = "April": moName(5) = "May": moName(6) = "June"
         moName(7) = "July": moName(8) = "August": moName(9) = "September"
         moName(10) = "October": moName(11) = "November": moName(12) = "December"
         dayName(1) = "S": dayName(2) = "M": dayName(3) = "T": dayName(4) = "W"
         dayName(5) = "T": dayName(6) = "F": dayName(7) = "S"
         CONTROL SET TEXT CBHNDL, %IDC_Year, RIGHT$(DATE$, 4)
         loadHolidays
         CONTROL SET FOCUS CBHNDL, %IDC_Year
      CASE %WM_COMMAND
         SELECT CASE CBCTL
            CASE %IDC_Year
               IF CB.CTLMSG = %EN_CHANGE THEN
                  CONTROL GET TEXT CB.HNDL, CB.CTL TO s
                  IF LEN(s) = 4 THEN loadHolidays
               END IF
            CASE %IDC_Holidays
               IF NOT alreadyLoaded THEN loadHolidays
               defineHolidays
            CASE %IDC_View
               viewCalendar
            CASE %IDC_Print
               IF NOT alreadyLoaded THEN loadHolidays
               printAttendance
            CASE %IDCANCEL
               CONTROL GET TEXT CBHNDL, %IDC_Year TO s
               fn = "Holidays" + RIGHT$(s, 2) + ".txt"
               IF ISFILE(fn) = 0 THEN
                  s = "Save holiday file for " + s
                  n = MSGBOX(s, %MB_ICONQUESTION OR %MB_YESNO, "Save Holidays")
                  IF n = %IDYES THEN
                     fileNum = FREEFILE
                     OPEN fn FOR OUTPUT AS fileNum
                     WRITE #fileNum, year, shade: n = numHolidays - 1
                     FOR i = 1 TO numHolidays
                        WRITE #fileNum, holidayName(i), holidayDate(i), holidayHalf(i)
                     NEXT i
                     CLOSE #fileNum
                  END IF
               END IF
               DIALOG END CBHNDL
         END SELECT
         CONTROL SEND CBHNDL, CBCTL, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
      CASE %WM_SYSCOMMAND
         IF CBWPARAM = %SC_CLOSE THEN
            DIALOG SEND CBHNDL, %WM_COMMAND, %IDCANCEL, 0
         ELSEIF CBWPARAM = %ID_SysMenu + 1 THEN
            s = "Attendance Records" + $CRLF _
              + "Version " + $ver + $CRLF + $CRLF _
              + "   by Charles Dietz" + $CRLF _
              + "   Email: chasdietz@verizon.net   " + $CRLF _
              + "   Website: www.cgdsoftware.com"
            MSGBOX s, , "About"
         END IF
   END SELECT
END FUNCTION

SUB loadHolidays()
   LOCAL i, fileNum, yr AS LONG, s AS STRING
   REDIM holidayName(25), holidayDate(25), holidayHalf(25), holidays(12, 31)
   CONTROL GET TEXT hDlg, %IDC_Year TO s: s = TRIM$(s): year = VAL(s)
   fileName = "Holidays" + RIGHT$(s, 2) + ".txt"
   IF ISFILE(fileName) = 0 THEN fileName = "holidays.txt"
   IF ISFILE(fileName) THEN
      fileNum = FREEFILE
      OPEN fileName FOR INPUT AS fileNum
      numHolidays = 0
      LINE INPUT #fileNum, s:
      yr = VAL(PARSE$(s, "", 1))
      shade = VAL(PARSE$(s, "", 2))
      IF shade = 0 THEN shade = 50
      WHILE NOT EOF(fileNum)
         LINE INPUT #fileNum, s
         IF LEN(s) THEN
            INCR i
            holidayName(i) = PARSE$(s, "", 1)
            holidayDate(i) = VAL(PARSE$(s, "", 2))
            holidayHalf(i) = VAL(PARSE$(s, "", 3))
         END IF
      WEND
      CLOSE #fileNum
      numHolidays = i
      alreadyLoaded = -1
   ELSE
      shade = 50: numHolidays = 7
      holidayName(1) = "New Years Day": holidayDate(1) = 101
      holidayName(2) = "Presidents Day"
      holidayName(3) = "Memorial Day"
      holidayName(4) = "Independence Day": holidayDate(4) = 704
      holidayName(5) = "Labor Day"
      holidayName(6) = "Thanksgiving Day"
      holidayName(7) = "Christmas Day": holidayDate(7) = 1225
   END IF
   getHolidayDates
   shade0 = shade
   FOR i = 1 TO numHolidays
      IF holidayDate(i) THEN
         holidays(holidayDate(i) \ 100, holidayDate(i) MOD 100) = holidayHalf(i) + 1
      END IF
   NEXT i
END SUB

SUB PrintAttendance()
   DIALOG NEW hDlg, "Print Attendance Record", , , 150, 150, %WS_SYSMENU TO hPrn
   CONTROL ADD CHECKBOX, hPrn, %IDC_Upper,"Print &top header", 10, 15, 100, 12
   CONTROL ADD CHECKBOX, hPrn, %IDC_Lower,"Print &bottom footer", 10, 30, 100, 12
   CONTROL ADD LABEL, hPrn, -1, "Holiday Shade:", 10, 62, 60, 12
   CONTROL ADD TEXTBOX, hPrn, %IDC_Buddy, "", 65, 60, 35, 15
   CONTROL ADD "msctls_updown32", hPrn, %IDC_UpDown, "", 0, 0, 8, 8, %WS_CHILD OR %WS_BORDER OR _
               %WS_VISIBLE OR %UDS_WRAP OR %UDS_ARROWKEYS OR %UDS_ALIGNRIGHT OR %UDS_SETBUDDYINT
   CONTROL ADD LABEL, hPrn, -1, "Darker", 102, 55, 25, 10
   CONTROL ADD LABEL, hPrn, -1, "Lighter", 102, 72, 25, 10
   CONTROL ADD BUTTON, hPrn, %IDOK, "&Ok", 40, 100, 40, 20, %WS_TABSTOP OR %BS_DEFAULT
   CONTROL ADD BUTTON, hPrn, %IDCANCEL, "&Cancel", 85, 100, 40, 20
   DIALOG SHOW MODAL hPrn, CALL PrintAttendanceProc
END SUB

CALLBACK FUNCTION PrintAttendanceProc()
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         CONTROL SET CHECK hPrn, %IDC_Upper, 1
         CONTROL SET CHECK hPrn, %IDC_Lower, 1
         'set upDown shade control
         CONTROL SEND hPrn, %IDC_UpDown, %UDM_SETBUDDY, GetDlgItem(hPrn, %IDC_Buddy), 0
         CONTROL SEND hPrn, %IDC_UpDown, %UDM_SETRANGE, 0, MAKLNG(100, 1)
         CONTROL SEND hPrn, %IDC_UpDown, %UDM_SETPOS, 0, shade
      CASE %WM_COMMAND
         IF CBCTL = %IDOK THEN
            CONTROL SEND hPrn, %IDC_UpDown, %UDM_GETPOS, 0, 0 TO shade
            IF shade <> shade0 THEN savChanges = 1
            printPage: DIALOG END CBHNDL
         ELSEIF CBCTL = %IDCANCEL THEN
            DIALOG END CBHNDL
         END IF
   END SELECT
END FUNCTION

SUB printPage()
   LOCAL xDeadZone, yDeadZone, prnErr, charHt, leftPrint, topPrint, topMoPrint AS LONG
   LOCAL di AS DOCINFO, tm AS TEXTMETRIC, xDpi, yDpi AS DOUBLE, s, jan AS STRING
   LOCAL i, x, y, yLine, w, u, xx, hPen, origPen, hFont, hBoldFont, origFont AS LONG
   LOCAL hPrinterDC, ROW, COL, m, prnTop, prnBottom AS LONG
   DIM xUpperLeftCorner(3), yUpperLeftCorner(4)
   hPrinterDC = choosePrinter(0)
   IF hPrinterDC = 0 THEN GOTO WrapUp
   hPen = CreatePen(%PS_SOLID, 4, 0)
   SelectObject hPrinterDC, hPen
   xDpi = GetDeviceCaps(hPrinterDC, %LOGPIXELSX)/100  'x-pixels per .01 inch
   yDpi = GetDeviceCaps(hPrinterDC, %LOGPIXELSY)/100  'y-pixels per .01 inch
   xDeadZone = GetDeviceCaps(hPrinterDC, %PHYSICALOFFSETX)
   yDeadZone = GetDeviceCaps(hPrinterDC, %PHYSICALOFFSETY)
   leftPrint = %LeftMargin * xDpi - xDeadZone
   topPrint  = %TopMargin * yDpi - yDeadZone
   topMoPrint  = %TopMoMargin * yDpi - yDeadZone
   monthWi = 7 * %cellWi * xDpi
   monthHt = 6 * %cellHt * yDpi
   xUpperLeftCorner(1) = leftPrint
   xUpperLeftCorner(2) = xUpperLeftCorner(1) + monthWi + %HorzSpac * xDpi
   xUpperLeftCorner(3) = xUpperLeftCorner(2) + monthWi + %HorzSpac * xDpi
   yUpperLeftCorner(1) = topMoPrint
   yUpperLeftCorner(2) = yUpperLeftCorner(1) + monthHt + %VertSpac * yDpi
   yUpperLeftCorner(3) = yUpperLeftCorner(2) + monthHt + %VertSpac * yDpi
   yUpperLeftCorner(4) = yUpperLeftCorner(3) + monthHt + %VertSpac * yDpi
   s = "Church Attendance"
   di.cbSize = SIZEOF(di)
   di.lpszDocName = VARPTR(s)
   IF StartDoc(BYVAL hPrinterDC, BYVAL VARPTR(di)) <= 0 THEN prnErr = 1: GOTO WrapUp
   IF StartPage(hPrinterDC) <= 0 THEN prnErr = 2: GOTO WrapUp
   CONTROL GET CHECK hPrn, %IDC_Upper TO prnTop
   CONTROL GET CHECK hPrn, %IDC_Lower TO prnBottom
   jan = moName(1)
   IF prnTop THEN
      '------------------------------------------------------- print 1st header and separator
      hFont = makeFont(hPrinterDC, 20)
      origFont = SelectObject(hPrinterDC, hFont)
      s = TRIM$(STR$(year)) + " ATTENDANCE RECORD for"
      x = leftPrint: y = topPrint
      showText hPrinterDC, x, y, s
      y = 50 * yDpi - yDeadZone
      x = leftPrint + 430 * xDpi: y = 50 * yDpi - yDeadZone: w = 320 * xDpi
      MoveToEx hPrinterDC, x, y, BYVAL %NULL
      lineTo hPrinterDC, x + w, y
      x = leftPrint: y = 125 * yDpi - yDeadZone: w = 750 * xDpi
      hPen = CreatePen(%PS_SOLID, 6, 0)
      origPen = SelectObject(hPrinterDC, hPen)
      MoveToEx hPrinterDC, x, y, BYVAL %NULL
      lineTo hPrinterDC, x + w, y
      '------------------------------------------------------- print 2nd header
      DIM TXT(5) AS STRING, lineLen(5) AS LONG
      TXT(1) = "Employee start date: ": TXT(2) = "Hours/week: ": TXT(3) = "End date: "
      TXT(4) = "Max vac accum: ": TXT(5) = "Max sick accum: 30 days "
      lineLen(1) = 60: lineLen(2) = 30: lineLen(3) = 60: lineLen(4) = 30
      hFont = makeFont(hPrinterDC, 10)
      SelectObject hPrinterDC, hFont
      hPen = CreatePen(%PS_SOLID, 2, 0)
      SelectObject hPrinterDC, hPen
      x = leftPrint: y = topPrint + 45*yDpi: yLine = topPrint + 58*yDpi: u = 10 * xDpi
      FOR i = 1 TO 5
         showText hPrinterDC, x, y, TXT(i)
         x = x + textLen(hPrinterDC, TXT(i))
         MoveToEx hPrinterDC, x, yLine, BYVAL %NULL
         x = x + lineLen(i) * xDpi
         lineTo hPrinterDC, x, yLine
         x = x + u
      NEXT i
      '------------------------------------------------------- print 3rd header
      REDIM TXT(8) AS STRING, key(8) AS STRING
      TXT(1) = " = Vac;": TXT(2) = " = Sick;": TXT(3) = " = Hol;": TXT(4) = " = Min.;"
      TXT(5) = " = Fltg. Hol.;": TXT(6) = " = Unpaid leave;": TXT(7) = " = Bereavement": TXT(8) = " = Paid leave"
      key(1) = "KEY:  V": key(2) = "S": key(3) = "H": key(4) = "M": key(5) = "F": key(6) = "L"
      key(7) = "B": key(8) = "P"
      hFont = makeFont(hPrinterDC, 10)
      hBoldFont = makeFont(hPrinterDC, 10, "Arial", "b")
      x = leftPrint + 15 * xDpi: y = 100 * yDpi - yDeadZone
      FOR i = 1 TO 8
         SelectObject hPrinterDC, hBoldFont
         showText hPrinterDC, x, y, key(i)
         x = x + textLen(hPrinterDC, key(i))
         SelectObject hPrinterDC, hFont
         showText hPrinterDC, x, y, TXT(i)
         x = x + textLen(hPrinterDC, TXT(i)) + u
      NEXT i
   ELSE
      moName(1) = jan + STR$(year)
   END IF
   '------------------------------------------------------- print months
   FOR i = 1 TO 12
      m = i - 1: ROW = (m \ 3) + 1: COL = (m MOD 3) + 1
      printMonth(hPrinterDC, i, xUpperLeftCorner(COL), yUpperLeftCorner(ROW))
   NEXT i
   IF prnBottom THEN
      '------------------------------------------------------- print footer
      hFont = makeFont(hPrinterDC, 18)
      SelectObject hPrinterDC, hFont
      s = "ACCRUALS"
      x = leftPrint + 375 * xDpi - textLen(hPrinterDC, s) / 2
      y = 925 * yDpi - yDeadZone
      showText hPrinterDC, x, y, s
      REDIM TXT(5) AS STRING
      s = "12/31/" + RIGHT$(TRIM$(STR$(year)), 2)
      TXT(1) = "Yearly vacation accrual rate"
      TXT(2) = "Vacation bal carried over from" + STR$(year - 1)
      TXT(3) = "Vacation earned as of " + s
      TXT(4) = "Vacation days taken in" + STR$(year)
      TXT(5) = "Vacation balance as of " + s
      hFont = makeFont(hPrinterDC, 11, "Tahoma")
      SelectObject hPrinterDC, hFont
      GetTextMetrics hPrinterDC, tm
      charHt = tm.tmHeight + tm.tmExternalLeading
      x = leftPrint: y = 956 * yDpi - yDeadZone: xx = leftPrint + 275 * xDpi
      FOR i = 1 TO 5
         showText hPrinterDC, x, y, TXT(i)
         showText hPrinterDc, xx, y, "______"
         y = y + 1.1 * charHt
      NEXT i
      TXT(1) = "Yearly sick/floating holiday: Sick__/FH __ days"
      TXT(2) = "Sick balance carried over from" + STR$(year - 1)
      TXT(3) = "Sick/FH days earned as of " + s
      TXT(4) = "Sick/FH days taken in " + STR$(year)
      TXT(5) = "Sick balance as of " + s
      SelectObject hPrinterDC, hFont
      x = leftPrint + 390 * xDpi: y = 956 * yDpi - yDeadZone: xx = leftPrint + 690 * xDpi
      FOR i = 1 TO 5
         showText hPrinterDC, x, y, TXT(i)
         IF i > 1 THEN showText hPrinterDc, xx, y, "___/___"
         y = y + 1.1 * charHt
      NEXT i
   END IF
WrapUp:
   moName(1) = jan
   IF prnErr THEN
      s = "Printing error has occured"
      MSGBOX s, %MB_ICONERROR, "Printing Error" + STR$(prnErr)
   END IF
   EndPage hPrinterDC
   EndDoc hPrinterDC
   SelectObject hPrinterDC, origFont
   SelectObject hPrinterDC, origPen
   DeleteObject hPen
   DeleteDC hPrinterDC
END SUB

SUB printMonth(hdc AS LONG, month AS LONG, x0 AS LONG, y0 AS LONG)
   LOCAL i, m, n, x, y, h, w, u AS LONG
   LOCAL startDay, days, hFont AS LONG
   LOCAL hBrush, hRgn, charHt, dark AS LONG
   LOCAL s AS STRING
   LOCAL tm AS TEXTMETRIC
   '------------------------------------------------------- print month template
   h = monthHt / 6: w = monthWi / 7: u = w / 5
   FOR i = 0 TO 6   'draw horizontal lines
      y = y0 + i * h
      MoveToEx hdc, x0, y, BYVAL %NULL
      lineTo hdc, x0 + monthWi, y
   NEXT i
   FOR i = 0 TO 7   'draw vertical lines
      x = x0 + i * w
      MoveToEx hdc, x, y0, BYVAL %NULL
      lineTo hdc, x, y0 + monthHt
   NEXT i
   '------------------------------------------------------- print day title
   hFont = makeFont(hdc, 10, "Courier New")
   SelectObject hdc, hFont
   GetTextMetrics hdc, tm
   charHt = tm.tmHeight + tm.tmExternalLeading
   y = y0 - 1.1 * charHt
   FOR i = 0 TO 6
      x = x0 + i * w + u: s = dayName(i + 1)
      showText hdc, x, y, s
   NEXT i
   '------------------------------------------------------- print month title
   hFont = makeFont(hdc, 12, "Arial", "b")
   SelectObject hdc, hFont
   GetTextMetrics hdc, tm
   charHt = tm.tmHeight + tm.tmExternalLeading
   y = y - charHt: x = x0: s = moName(month)
   showText hdc, x, y, s
   '------------------------------------------------------- print calendar days
   hFont = makeFont(hdc, 6)
   SelectObject hdc, hFont
   startDay = dayOfWeek(month, 1, year)
   days = daysInMonth(month, year)
   m = 0: n = startDay: u = .10 * w
   'IF shade = 0 THEN shade = 50
   dark = 255 - 155/99*(shade - 1)
   FOR i = 1 TO days
      x = x0 + n * w: y = y0 + m * h
      IF holidays(month, i) THEN
         hBrush = CreateSolidBrush(RGB(dark, dark, dark))
         IF holidays(month, i) = 2 THEN 'half day
            hRgn = CreateRectRgn(x + 1, y + h/2 + 1, x + w - 1, y + h - 1)
         ELSE
            hRgn = CreateRectRgn(x + 1, y + 1, x + w - 1, y + h - 1)
         END IF
         FillRgn hdc, hRgn, hBrush
         DeleteObject hBrush
         DeleteObject hRgn
      END IF
      x = x + u: y = y + u/2
      showText hdc, x, y, TRIM$(STR$(i))
      INCR n: IF n MOD 7 = 0 THEN INCR m: n = 0
   NEXT i
END SUB

FUNCTION choosePrinter(landscape AS LONG) AS DWORD  'LONG
   'return printer device context for selected printer
   'landscape = 1  for landscape
   '          = 0  for portrait
   LOCAL pd AS PRINTDLGAPI, pDevMode AS DEVMODE PTR, hPrnDC AS DWORD  'LONG
   pd.lStructSize = SIZEOF(pd)
   pd.hWndOwner = hDlg
   pd.Flags = %PD_RETURNDC OR %PD_NOSELECTION OR %PD_NOPAGENUMS OR %PD_HIDEPRINTTOFILE
   IF printDlg(pd) THEN
     hPrnDC = pd.hdc
     IF landscape THEN
        pDevMode = GlobalLock(pd.hDevMode)
        @pDevMode.dmOrientation = %DMORIENT_LANDSCAPE
        ResetDC hPrnDC, BYVAL pDevMode
        GlobalUnlock pDevMode
     END IF
   END IF
   FUNCTION = hPrnDC
END FUNCTION

FUNCTION textLen(hdc AS LONG, s AS STRING) AS LONG
   'returns length of text in pixels
   LOCAL sz AS ASCIIZ * 128, t AS SIZEL
   sz = s: GetTextExtentPoint32 hdc, sz, LEN(sz), t
   FUNCTION = t.cx
END FUNCTION

SUB defineHolidays()
   LOCAL STYLE AS LONG
   DIALOG NEW hDlg, "Define Holidays", , , 200, 200, %WS_SYSMENU TO hDefineHolidays
   STYLE = %WS_VSCROLL + %LBS_DISABLENOSCROLL + %WS_TABSTOP + %LBS_USETABSTOPS
   CONTROL ADD LISTBOX, hDefineHolidays, %IDC_HolidayLB, , 5, 10, 185, 140, STYLE, %WS_EX_CLIENTEDGE
   CONTROL ADD BUTTON, hDefineHolidays, %IDC_AddHoliday, "&Add", 10, 155, 40, 20
   CONTROL ADD BUTTON, hDefineHolidays, %IDC_EdtHoliday, "&Edit", 50, 155, 40, 20
   CONTROL ADD BUTTON, hDefineHolidays, %IDC_DelHoliday, "&Remove", 90, 155, 40, 20
   CONTROL ADD BUTTON, hDefineHolidays, %IDC_SavHolidays, "&Save", 140, 155, 40, 20
   DIALOG SHOW MODAL hDefineHolidays, CALL defineHolidaysProc
END SUB

CALLBACK FUNCTION defineHolidaysProc
   LOCAL i, n, fileNum AS LONG
   LOCAL s, fn AS STRING
   DIM holidayName(1 TO 25), holidayDate(1 TO 25), holidayHalf(1 TO 25)
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         listHolidays
         CONTROL GET TEXT hDlg, %IDC_Year TO s
         fn = "Holidays" + RIGHT$(s, 2) + ".txt"
         IF ISFILE(fn) THEN CONTROL DISABLE CB.HNDL, %IDC_SavHolidays
      CASE %WM_COMMAND
         IF CBCTL = %IDC_AddHoliday THEN
            holidayNo = 0: addHoliday
         ELSEIF CBCTL = %IDC_EdtHoliday THEN
            CONTROL SEND CBHNDL, %IDC_HolidayLB, %LB_GETCURSEL, 0, 0 TO n
            holidayNo = n + 1: addHoliday
         ELSEIF CBCTL = %IDC_DelHoliday THEN
            CONTROL SEND CBHNDL, %IDC_HolidayLB, %LB_GETCURSEL, 0, 0 TO n
            holidayNo = n + 1: s = "Remove this holiday now?      "
            n = MSGBOX(s, %MB_ICONQUESTION OR %MB_YESNO, holidayName(holidayNo))
            IF n = %IDYES THEN
               deleteHoliday(holidayNo): listHolidays
            END IF
         ELSEIF CBCTL = %IDC_SavHolidays THEN
            CONTROL GET TEXT hDlg, %IDC_Year TO s
            fn = "Holidays" + RIGHT$(s, 2) + ".txt"
            IF savChanges OR ISFILE(fn) = 0 THEN
               s = "Save holiday file for " + s
               n = MSGBOX(s, %MB_ICONQUESTION OR %MB_YESNO, "Save Holidays")
               IF n = %IDYES THEN
                  fileNum = FREEFILE
                  OPEN fn FOR OUTPUT AS fileNum
                  WRITE #fileNum, year, shade: n = numHolidays - 1
                  FOR i = 1 TO numHolidays
                     WRITE #fileNum, holidayName(i), holidayDate(i), holidayHalf(i)
                  NEXT i
                  WRITE #fileNum,
                  CLOSE #fileNum
                  savChanges = 0
                  DIALOG END CB.HNDL
               END IF
            END IF
         ELSEIF CBCTL = %IDCANCEL THEN
            DIALOG END CB.HNDL
         END IF
         CONTROL SEND CBHNDL, CBCTL, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
   END SELECT
END FUNCTION

SUB addHoliday()
   LOCAL hAddHoliday AS LONG
   DIALOG NEW hDefineHolidays, STR$(year) + " Holidays", , , 180, 140, %WS_SYSMENU TO hAddHoliday
   CONTROL ADD LABEL, hAddHoliday, -1, "Holiday:", 10, 20, 40, 12
   CONTROL ADD TEXTBOX, hAddHoliday, %IDC_HolidayName, "", 50, 20, 100, 12
   CONTROL ADD LABEL, hAddHoliday, -1, "Month-day:", 10, 40, 40, 12
   CONTROL ADD TEXTBOX, hAddHoliday, %IDC_HolidayDate, "", 50, 40, 30, 12
   CONTROL ADD CHECKBOX, hAddHoliday, %IDC_HalfDay, "Half Day", 110, 40, 50, 12
   CONTROL ADD BUTTON, hAddHoliday, %IDOK, "Ok", 40, 70, 50, 20
   CONTROL ADD BUTTON, hAddHoliday, %IDCANCEL, "&Cancel", 100, 70, 50, 20
   DIALOG SHOW MODAL hAddHoliday, CALL addHolidayProc
END SUB

CALLBACK FUNCTION addHolidayProc()
   LOCAL n, k, mo, day AS LONG
   LOCAL s, s1 AS STRING
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         IF holidayNo THEN
            CONTROL SET TEXT CBHNDL, %IDC_HolidayName, holidayName(holidayNo)
            n = holidayDate(holidayNo)
            s = FORMAT$(n \ 100, "00"): s1 = FORMAT$(n MOD 100, "00")
            CONTROL SET TEXT CBHNDL, %IDC_HolidayDate, s + "-" + s1
            CONTROL SET CHECK CBHNDL, %IDC_HalfDay, holidayHalf(holidayNo)
         END IF
      CASE %WM_COMMAND
         IF CBCTL = %IDOK THEN
            savChanges = 1: INCR numHolidays
            IF holidayNo THEN deleteHoliday(holidayNo)
            CONTROL GET TEXT CBHNDL, %IDC_HolidayDate TO s
            mo = VAL(PARSE$(s, "-", 1)): day = VAL(PARSE$(s, "-", 2))
            n = 100 * mo + day: holidays(mo, day) = 1
            ARRAY SCAN holidayDate(), > n, TO holidayNo
            IF holidayNo = 0 THEN holidayNo = numHolidays
            CONTROL GET TEXT CBHNDL, %IDC_HolidayName TO s
            CONTROL GET CHECK CBHNDL, %IDC_HalfDay TO k
            ARRAY INSERT holidayName(holidayNo), s
            ARRAY INSERT holidayDate(holidayNo), n
            ARRAY INSERT holidayHalf(holidayNo), k
            IF k THEN INCR holidays(mo, day)
            listHolidays: DIALOG END CBHNDL
            CONTROL ENABLE hDefineHolidays, %IDC_SavHolidays
         ELSEIF CBCTL = %IDCANCEL THEN
            DIALOG END CBHNDL
         END IF
   END SELECT
END FUNCTION

SUB deleteHoliday(index AS LONG)
   LOCAL mo, day AS LONG
   mo = holidayDate(index)\100
   day = holidayDate(index) MOD 100
   holidays(mo, day) = 0
   DECR numHolidays: savChanges = 1
   ARRAY DELETE holidayName(index)
   ARRAY DELETE holidayDate(index)
   ARRAY DELETE holidayHalf(index)
   CONTROL ENABLE hDefineHolidays, %IDC_SavHolidays
END SUB

SUB listHolidays
   LOCAL i AS LONG, mo AS LONG, day AS LONG, lptr AS LONG PTR
   LOCAL s AS STRING, s1 AS STRING, s2 AS STRING
   DIM tabstops(2) AS LONG
   tabstops(0) = 0     'holiday name
   tabstops(1) = 100   'holiday date
   tabstops(2) = 140   'half day
   lptr = VARPTR(tabstops(0))
   CONTROL SEND hDefineHolidays, %IDC_HolidayLB, %LB_SETTABSTOPS, 3, lptr
   LISTBOX RESET hDefineHolidays, %IDC_HolidayLB
   FOR i = 1 TO numHolidays
      mo = holidayDate(i) / 100: day = holidayDate(i) MOD 100
      s1 = FORMAT$(mo, "00") + "-" + FORMAT$(day, "00")
      IF holidayHalf(i) THEN s2 = "half day" ELSE s2 = ""
      s = holidayName(i) + $TAB + s1 + $TAB + s2
      LISTBOX ADD hDefineHolidays, %IDC_HolidayLB, s
   NEXT i
   LISTBOX SELECT hDefineHolidays, %IDC_HolidayLB, MAX(holidayNo, 1)
END SUB

SUB viewCalendar()
   'view holidays by calendar months
   LOCAL STYLE AS LONG
   STYLE = %DS_MODALFRAME OR %WS_BORDER OR %WS_CAPTION OR %WS_CLIPSIBLINGS OR %WS_DLGFRAME
   STYLE = STYLE OR %WS_POPUP OR %WS_VSCROLL OR %WS_SYSMENU OR %WS_MINIMIZEBOX
   DIALOG NEW hDlg, STR$(year) + " Holidays", , , 500, 270, STYLE TO hViewHolidays
   DIALOG SET COLOR hViewHolidays, -1, %WHITE
   DIALOG SHOW MODAL hViewHolidays, CALL viewCalendarProc
END SUB

CALLBACK FUNCTION viewCalendarProc()
   LOCAL hPen AS LONG, horizSpac AS LONG, xDpi AS LONG, yDpi AS LONG
   LOCAL i AS LONG, m AS LONG, n AS LONG, ROW AS LONG, COL AS LONG
   LOCAL ps AS PAINTSTRUCT, x AS LONG, y AS LONG, VIEW AS BYTE
   STATIC hdc AS LONG, si AS SCROLLINFO
   DIM xUpperLeftCorner(3), yUpperLeftCorner(4)
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         hdc = Getdc(CBHNDL)
         hPen = CreatePen(%PS_SOLID, 1, 0)
         SelectObject hdc, hPen
         xDpi = GetDeviceCaps(hdc, %LOGPIXELSX)/100  'x-pixels per .01 inch
         yDpi = GetDeviceCaps(hdc, %LOGPIXELSY)/100  'y-pixels per .01 inch
         monthWi = 7 * %cellWi * xDpi
         monthHt = 6 * %cellHt * yDpi
         horizSpac = 20
         xUpperLeftCorner(1) = 20
         xUpperLeftCorner(2) = xUpperLeftCorner(1) + monthWi + horizSpac * xDpi
         xUpperLeftCorner(3) = xUpperLeftCorner(2) + monthWi + horizSpac * xDpi
         yUpperLeftCorner(1) = 50
         yUpperLeftCorner(2) = yUpperLeftCorner(1) + monthHt + %VertSpac * yDpi
         yUpperLeftCorner(3) = yUpperLeftCorner(2) + monthHt + %VertSpac * yDpi
         yUpperLeftCorner(4) = yUpperLeftCorner(3) + monthHt + %VertSpac * yDpi
         'set scroll information --------------------------------------------------------
         si.cbSize = SIZEOF(si): si.fMask = %SIF_ALL
         si.nMin = 0: si.nMax = 2: si.nPos = 0: si.nPage = 2
         SetScrollInfo BYVAL CBHNDL, BYVAL %SB_VERT, si, 1
         vpos = 0
      CASE %WM_PAINT
         hdc = BeginPaint(CB.HNDL, ps)
            IF vpos THEN n = 7 ELSE n = 1
            FOR i = n TO n + 5
               m = i - n: ROW = (m \ 3) + 1: COL = (m MOD 3) + 1
               x = xUpperLeftCorner(COL): y = yUpperLeftCorner(ROW)
               printMonth hdc, i, x, y
            NEXT i
         EndPaint CB.HNDL, ps
      CASE %WM_VSCROLL
         SELECT CASE LOWRD(CBWPARAM)
            CASE %SB_LINEDOWN
               IF vpos < 3 THEN vpos = 3: VIEW = 1
            CASE %SB_LINEUP
               IF vpos > 0 THEN vpos = 0: VIEW = 1
            CASE %SB_THUMBTRACK
               vpos = HIWRD(CBWPARAM): VIEW = 1
            CASE %SB_PAGEDOWN
               IF vpos < 3 THEN vpos = 3: VIEW = 1
            CASE %SB_PAGEUP
               IF vpos > 0 THEN vpos = 0: VIEW = 1
         END SELECT
         IF VIEW THEN
            VIEW = 0
            SetScrollPos CBHNDL, %SB_VERT, vPos, 1
            InvalidateRect CBHNDL, BYVAL %NULL, 1
         END IF
      CASE %WM_COMMAND
         IF CBCTL = %IDCANCEL THEN DIALOG END CBHNDL
   END SELECT
END FUNCTION

SUB getHolidayDates()
   LOCAL i, j, n, mo, day AS LONG
   'LOCAL half AS BYTE
   FOR i = 1 TO numHolidays
      mo = holidayDate(i) / 100: day = holidayDate(i) MOD 100
      IF holidayDate(i) < 0 THEN 'date has been overriden, don't change
         ITERATE
      ELSEIF holidayDate(i) = 0 THEN
         n = dayOfWeek(mo, 1, year)
         IF INSTR(holidayName(i), "Presidents") THEN
            '3rd Mon in Feb
            'find 1st Mon in Feb then add 14 days
            mo = 2: n = dayOfWeek(mo, 1, year)
            IF n > 1 THEN day = 23 - n ELSE day = 16 - n
         ELSEIF INSTR(holidayName(i), "Memorial") THEN
            'last Mon in May
            'find 1st Mon in Feb then add either 21 or 28 days
            mo = 5: n = dayOfWeek(mo, 1, year)
            IF n > 1 THEN day = 30 - n ELSE day = 23 - n
            IF day + 7 <= 30 THEN day = day + 7
         ELSEIF INSTR(HolidayName(i), "Labor") THEN
            '1st Mon in Sept
            mo = 9: n = dayOfWeek(mo, 1, year)
            IF n > 1 THEN day = 9 - n ELSE day = 2 - n
         ELSEIF INSTR(holidayName(i), "Thanksgiving") THEN
            '4th Thurs in Nov
            'find 1st Thurs then add 21 days
            mo = 11: n = dayOfWeek(mo, 1, year)
            IF n > 4 THEN day = 33 - n ELSE day = 26 - n
            IF holidayHalf(i) = 1 THEN DECR day
            IF holidayHalf(i) = 2 THEN INCR day
         END IF
      END IF
      holidayDate(i) = mo * 100 + day
   NEXT i
END SUB

FUNCTION daysInMonth(mo AS LONG, yr AS LONG) AS LONG
   LOCAL days AS INTEGER
   IF mo < 8 THEN
      days = 30 + mo MOD 2
   ELSE
      days = 30 + (mo + 1) MOD 2
   END IF
   IF mo = 2 THEN
      days = 28
      IF (yr MOD 100 <> 0 OR yr MOD 400 = 0) _
         AND yr MOD 4 = 0 THEN INCR days 'leap yr
   END IF
   daysInMonth = days
END FUNCTION

FUNCTION dayOfWeek(mo AS LONG, day AS LONG, yr AS LONG) AS LONG
   'Sun=0, Mon=1, Tue=2,... Sat=6
   LOCAL n AS INTEGER
   n = yr - 1899 + (yr - 1901) \ 4
   IF mo < 8 THEN
      n = n + 30 * (mo - 1) + mo \ 2
   ELSE
      n = n + 30 * (mo - 1) + (mo + 1) \ 2
   END IF
   IF mo > 2 THEN
      n = n - 2
      IF (yr MOD 100 <> 0 OR yr MOD 400 = 0) _
         AND yr MOD 4 = 0 THEN IF mo > 2 THEN INCR n 'leap yr
   END IF
   FUNCTION = (n + day - 1) MOD 7
END FUNCTION

SUB showText(hdc AS LONG, x AS LONG, y AS LONG, TXT AS STRING)
   SetBkMode(hdc, %TRANSPARENT)
   TextOut hdc, x, y, BYVAL STRPTR(TXT), LEN(TXT)
END SUB

FUNCTION MakeFont(hDC AS LONG, BYVAL ptSize AS LONG, _
                  OPT BYVAL sFont AS STRING, BYVAL descr AS STRING) AS LONG
   'some font choices: "Arial", "Courier New", "Times New Roman", "MS Sans Serif", "Tahoma"
   'default font: "Arial"; fixed width font: "Courier New"
   'specify descr = "b" for bold, "u" for underline, "i" for italic
   LOCAL CyPixels AS LONG, charHt AS LONG, wt AS DWORD
   LOCAL BOLD AS DWORD, underline AS DWORD, italic AS DWORD
   IF LEN(sFont) = 0 THEN sFont = "Arial"
   IF LEN(descr) THEN
      BOLD = INSTR(descr, "b") + 300
      underline = INSTR(descr,"u")
      italic = INSTR(descr,"i")
   END IF
   CyPixels  = GetDeviceCaps(hDC, %LOGPIXELSY)
   charHt = (PtSize * CyPixels) \ 72
   wt = %FW_NORMAL + BOLD
   FUNCTION = CreateFont(-charHt, 0, 0, 0, wt, italic, underline, 0, _
              %ANSI_CHARSET, %OUT_TT_PRECIS, %CLIP_DEFAULT_PRECIS, _
              %DEFAULT_QUALITY, %FF_DONTCARE, BYCOPY sFont)
END FUNCTION
